part of '../flutterx_live_data.dart';

abstract class LiveData<T> extends ObservableData<T> {
  T get value => _data;

  T? get valueOrNull => initialized ? _data : null;

  LiveData({super.equality});
}

class MediatorLiveData<T> extends LiveData<T> with MediatorMixin<T> {
  MediatorLiveData({bool reactive = false}) {
    this.reactive = reactive;
  }

  MediatorLiveData.copy(ObservableData<T> source, {bool reactive = false}) {
    this.reactive = reactive;
    addSource<T>(source, _setData);
  }
}
