part of '../flutterx_live_data.dart';

abstract class SelfLiveData<T extends SelfLiveData<T>> extends ObservableData<T> {
  final Set<ObservableData> _sources = {};

  SelfLiveData() {
    super._setData(this as T);
  }

  void setFields(Iterable<ObservableData> fields) {
    fields = {...fields};
    for (final source in [..._sources]) if (!fields.contains(source)) removeField(source);
    fields.forEach(addField);
  }

  void addField(ObservableData field) => _sources.add(field) ? field.observeForever(_invalidate) : null;

  void removeField(ObservableData field) => _sources.remove(field) ? field.removeObserver(_invalidate) : null;

  @override
  @nonVirtual
  void _setData(T value) => throw UnsupportedError('cannot set this instance');

  void _invalidate(dynamic _) => invalidate();
}
