part of '../flutterx_live_data.dart';

class LiveEvent<T> extends ObservableData<T> {
  LiveEvent() : super(equality: const _NeverEqualsEquality());

  void postSend(FutureOr<T> value) => _postSetData(value);

  void send(T value) => _setData(value);

  @override
  ObserverWrapper<T> observeForever(Observer<T> onChanged, {Dispatcher? dispatcher}) =>
      addObserverWrapper(EventObserverWrapper<T>(onChanged, dispatcher));
}

class EventObserverWrapper<T> extends ObserverWrapper<T> {
  EventObserverWrapper(super.onChanged, super.dispatcher);

  @override
  void onAdded(ObservableData<T> data) {}
}

class MediatorLiveEvent<T> extends LiveEvent<T> with MediatorMixin<T> {
  MediatorLiveEvent({bool reactive = false}) {
    this.reactive = reactive;
  }
}

class _NeverEqualsEquality implements Equality<Never> {
  const _NeverEqualsEquality();

  @override
  bool equals(Object? e1, Object? e2) => false;

  @override
  int hash(Object? e) => e.hashCode;

  @override
  bool isValidKey(Object? o) => true;
}
